#include <aes.h>
#include <stddef.h>
#include <cpxdata.h>
#include <string.h>
#include <tos.h>
#include "resource.h"
#include "resource.c"

CPXINFO *cdecl cpx_init(XCPB *Xcpb);
WORD     cdecl cpx_call(GRECT *rect);
int      modul_off, mode;

extern int detect_vga(void);
extern void reboot(void);

XCPB *xcpb;
CPXINFO cpxinfo = 
{
  cpx_call, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL
};

const char *popup[]={ "    VGA ","   Mono ","  Color ", };
const char *modes[]={ "VGA","Mono","Color","???" };
const char *pop2[]={ "  An ","  Aus " };
const char *on[]={ "An","Aus" };
const char *names[]={ "keine","VOFA","STGA" };

int get_val(void) {
	int ret;
	long sp=Super(0l);
	if( *(long*)0x3fa != 0x12345678l ) 
		ret=-1;
	else
		ret=*(int*)0x3fe;
	Super((void*)sp);

	return ret;
}

void set_val(int val) {
	long sp=Super(0l);
	*(long*)0x3fa=0x12345678l; 
	*(int*)0x3fe=val;
	Super((void*)sp);
}
	
CPXINFO *cdecl cpx_init(XCPB *Xcpb)
{
	WORD i;
	xcpb=Xcpb;

	/* Bootvorgang? CPX sollerscheinen */
	if(xcpb->booting) return((CPXINFO*)1);
	
	/* LASTOB sollte wirklich letztes sein */
	if(!xcpb->SkipRshFix) {
		i=0; 
		do
			(*xcpb->rsh_obfix)(tree0_obj,i);
		while(!(tree0_obj[i++].ob_flags&LASTOB));
	}

	/* ist ueberhaupt ein Modul da? */
  	if( *(long*)0xfa0018 == 0x53544741 ) {  /* STGA */
  		i=*(int*)0xfa0026;    /* STGA-MOD-Version */
  		tree0_obj[VERSION].ob_spec.free_string[0]='0'+i/256;
  		tree0_obj[VERSION].ob_spec.free_string[2]='0'+i%256;
		tree0_obj[REBOOT].ob_state &= ~DISABLED;
		tree0_obj[MODE].ob_state   &= ~DISABLED;
		tree0_obj[MON].ob_state    &= ~DISABLED;
  	} else {
  	  	strcpy(tree0_obj[VERSION].ob_spec.free_string,"???");
		tree0_obj[REBOOT].ob_state |= DISABLED;
		tree0_obj[MODE].ob_state   |= DISABLED;
		tree0_obj[MON].ob_state    |= DISABLED;
	}	

	/* keine/STGA/VOFA testen */
	tree0_obj[NAME].ob_spec.free_string = names[detect_vga()];

	/* magic auswerten */
	if(get_val()<0) {  /* kein Magic */
		mode=0;        /* VGA */
		modul_off=0;   /* An */
		set_val(0);
	} else {
		if((mode=get_val()&3)>2) mode=0;
		modul_off=(get_val()&4)?1:0;
	}

	tree0_obj[MODE].ob_spec.tedinfo->te_ptext=modes[mode];
	tree0_obj[MON].ob_spec.tedinfo->te_ptext=on[modul_off];

	return &cpxinfo;
}

WORD cdecl cpx_call(GRECT *rect)
{
	WORD msg[8],obj,i;
	GRECT obi;
	
	tree0_obj[ROOT].ob_x=rect->g_x;
	tree0_obj[ROOT].ob_y=rect->g_y;
	
	objc_draw(tree0_obj, ROOT, MAX_DEPTH, 
		rect->g_x, rect->g_y, rect->g_w, rect->g_h);
		
	do {
		obj=(*xcpb->Xform_do)(tree0_obj,0,msg);
		switch(obj) {
			case -1:
				if(msg[0]==AC_CLOSE)  obj=ABBRUCH;
				if(msg[0]==WM_CLOSED) obj=OK;
				break;
		
			case MODE: 
				if(!(tree0_obj[MODE].ob_state&DISABLED)) {
					objc_offset(tree0_obj,MODE,&obi.g_x,&obi.g_y);
					obi.g_w=tree0_obj[MODE].ob_width;
					obi.g_h=tree0_obj[MODE].ob_height;
					if((i=(*xcpb->Popup)(popup,3,mode,3,&obi,&tree0_obj[ROOT].ob_x))>=0) {
						tree0_obj[MODE].ob_spec.tedinfo->te_ptext=modes[i];
						objc_draw(tree0_obj, MODE, MAX_DEPTH, 
								rect->g_x, rect->g_y, rect->g_w, rect->g_h);
						mode=i;
					}
				}
				break;
				
			case MON: 
				if(!(tree0_obj[MON].ob_state&DISABLED)) {
					objc_offset(tree0_obj,MON,&obi.g_x,&obi.g_y);
					obi.g_w=tree0_obj[MON].ob_width;
					obi.g_h=tree0_obj[MON].ob_height;
					if((i=(*xcpb->Popup)(pop2,2,modul_off,3,&obi,&tree0_obj[ROOT].ob_x))>=0) {
						tree0_obj[MON].ob_spec.tedinfo->te_ptext=on[i];
						objc_draw(tree0_obj, MON, MAX_DEPTH, 
								rect->g_x, rect->g_y, rect->g_w, rect->g_h);
						modul_off=i;
					}
				}
				break;

			case REBOOT:
				if(modul_off)
					set_val(mode|4);
				else
					set_val(mode);

				reboot();
				break;
		}
	} while((obj!=OK)&&(obj!=ABBRUCH));
	
	/* Daten eintragen */
  	if( *(long*)0xfa0018 == 0x53544741 ) {  /* STGA */
		if(obj==OK) {
			if(modul_off)
				set_val(mode|4);
			else
				set_val(mode);
		}
	}
	
	return 0;
}

